'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var getPages = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref) {
    var dir = _ref.dir,
        dev = _ref.dev,
        pagesGlobPattern = _ref.pagesGlobPattern;
    var pages;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            pages = void 0;

            if (!dev) {
              _context.next = 7;
              break;
            }

            _context.next = 4;
            return (0, _globPromise2.default)('pages/+(_document|_error).+(js|jsx)', { cwd: dir });

          case 4:
            pages = _context.sent;
            _context.next = 10;
            break;

          case 7:
            _context.next = 9;
            return (0, _globPromise2.default)(pagesGlobPattern, { cwd: dir });

          case 9:
            pages = _context.sent;

          case 10:
            return _context.abrupt('return', pages);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getPages(_x) {
    return _ref2.apply(this, arguments);
  };
}();

var _path = require('path');

var _crypto = require('crypto');

var _fs = require('fs');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _globPromise = require('glob-promise');

var _globPromise2 = _interopRequireDefault(_globPromise);

var _writeFileWebpackPlugin = require('write-file-webpack-plugin');

var _writeFileWebpackPlugin2 = _interopRequireDefault(_writeFileWebpackPlugin);

var _friendlyErrorsWebpackPlugin = require('friendly-errors-webpack-plugin');

var _friendlyErrorsWebpackPlugin2 = _interopRequireDefault(_friendlyErrorsWebpackPlugin);

var _caseSensitivePathsWebpackPlugin = require('case-sensitive-paths-webpack-plugin');

var _caseSensitivePathsWebpackPlugin2 = _interopRequireDefault(_caseSensitivePathsWebpackPlugin);

var _uglifyjsWebpackPlugin = require('uglifyjs-webpack-plugin');

var _uglifyjsWebpackPlugin2 = _interopRequireDefault(_uglifyjsWebpackPlugin);

var _unlinkFilePlugin = require('./plugins/unlink-file-plugin');

var _unlinkFilePlugin2 = _interopRequireDefault(_unlinkFilePlugin);

var _pagesPlugin = require('./plugins/pages-plugin');

var _pagesPlugin2 = _interopRequireDefault(_pagesPlugin);

var _dynamicChunksPlugin = require('./plugins/dynamic-chunks-plugin');

var _dynamicChunksPlugin2 = _interopRequireDefault(_dynamicChunksPlugin);

var _combineAssetsPlugin = require('./plugins/combine-assets-plugin');

var _combineAssetsPlugin2 = _interopRequireDefault(_combineAssetsPlugin);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _babelCore = require('babel-core');

var babelCore = _interopRequireWildcard(_babelCore);

var _findConfig = require('./babel/find-config');

var _findConfig2 = _interopRequireDefault(_findConfig);

var _rootModuleRelativePath = require('./root-module-relative-path');

var _rootModuleRelativePath2 = _interopRequireDefault(_rootModuleRelativePath);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var documentPage = (0, _path.join)('pages', '_document.js');
var defaultPages = ['_error.js', '_document.js'];
var nextPagesDir = (0, _path.join)(__dirname, '..', '..', 'pages');
var nextNodeModulesDir = (0, _path.join)(__dirname, '..', '..', '..', 'node_modules');
var interpolateNames = new _map2.default(defaultPages.map(function (p) {
  return [(0, _path.join)(nextPagesDir, p), 'dist/pages/' + p];
}));

var relativeResolve = (0, _rootModuleRelativePath2.default)(require);

function getPageEntries(pages) {
  var entries = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(pages), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var p = _step.value;

      entries[(0, _path.join)('bundles', p.replace('.jsx', '.js'))] = ['./' + p + '?entry'];
    }

    // The default pages (_document.js and _error.js) are only added when they're not provided by the user
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = (0, _getIterator3.default)(defaultPages), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _p = _step2.value;

      var entryName = (0, _path.join)('bundles', 'pages', _p);
      if (!entries[entryName]) {
        entries[entryName] = [(0, _path.join)(nextPagesDir, _p) + '?entry'];
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return entries;
}

exports.default = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(dir) {
    var _this = this;

    var _ref4 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        buildId = _ref4.buildId,
        _ref4$dev = _ref4.dev,
        dev = _ref4$dev === undefined ? false : _ref4$dev,
        _ref4$quiet = _ref4.quiet,
        quiet = _ref4$quiet === undefined ? false : _ref4$quiet,
        buildDir = _ref4.buildDir,
        _ref4$conf = _ref4.conf,
        conf = _ref4$conf === undefined ? null : _ref4$conf;

    var totalPages, config, devEntries, mainJS, entry, plugins, nodePathList, mainBabelOptions, externalBabelConfig, options, devLoaders, loaders, webpackConfig;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            // Resolve relative path to absolute path
            dir = (0, _fs.realpathSync)((0, _path.resolve)(dir));

            // Used to track the amount of pages for webpack commons chunk plugin
            totalPages = void 0;

            // Loads next.config.js and custom configuration provided in custom server initialization

            config = (0, _config2.default)(dir, conf);

            // Middlewares to handle on-demand entries and hot updates in development

            devEntries = dev ? [(0, _path.join)(__dirname, '..', '..', 'client', 'webpack-hot-middleware-client'), (0, _path.join)(__dirname, '..', '..', 'client', 'on-demand-entries-client')] : [];
            mainJS = require.resolve('../../client/next' + (dev ? '-dev' : '')); // Uses client/next-dev in development for code splitting dev dependencies

            entry = function () {
              var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
                var pages, pageEntries, entries;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return getPages({ dir: dir, dev: dev, pagesGlobPattern: config.pagesGlobPattern });

                      case 2:
                        pages = _context2.sent;
                        pageEntries = getPageEntries(pages);

                        // Used for commons chunk calculations

                        totalPages = pages.length;
                        if (pages.indexOf(documentPage) !== -1) {
                          totalPages = totalPages - 1;
                        }

                        entries = (0, _extends3.default)({
                          'main.js': [].concat(devEntries, (0, _toConsumableArray3.default)(config.clientBootstrap || []), [// clientBootstrap can be used to load polyfills before code execution
                          mainJS // Main entrypoint in the client folder
                          ])
                        }, pageEntries);
                        return _context2.abrupt('return', entries);

                      case 8:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function entry() {
                return _ref5.apply(this, arguments);
              };
            }();

            plugins = [
            // Defines NODE_ENV as development/production. This is used by some npm modules to determine if they should optimize.
            new _webpack2.default.DefinePlugin({
              'process.env.NODE_ENV': (0, _stringify2.default)(dev ? 'development' : 'production')
            }), new _caseSensitivePathsWebpackPlugin2.default(), // Since on macOS the filesystem is case-insensitive this will make sure your path are case-sensitive
            new _webpack2.default.IgnorePlugin(/(precomputed)/, /node_modules.+(elliptic)/),
            // Provide legacy options to webpack
            new _webpack2.default.LoaderOptionsPlugin({
              options: {
                context: dir,
                customInterpolateName: function customInterpolateName(url, name, opts) {
                  return interpolateNames.get(this.resourcePath) || url;
                }
              }
            }),
            // Writes all generated files to disk, even in development. For SSR.
            new _writeFileWebpackPlugin2.default({
              exitOnErrors: false,
              log: false,
              // required not to cache removed files
              useHashIndex: false
            }),
            // Moves common modules into commons.js
            new _webpack2.default.optimize.CommonsChunkPlugin({
              name: 'commons',
              filename: 'commons.js',
              minChunks: function minChunks(module, count) {
                // We need to move react-dom explicitly into common chunks.
                // Otherwise, if some other page or module uses it, it might
                // included in that bundle too.
                if (dev && module.context && module.context.indexOf(_path.sep + 'react' + _path.sep) >= 0) {
                  return true;
                }

                if (dev && module.context && module.context.indexOf(_path.sep + 'react-dom' + _path.sep) >= 0) {
                  return true;
                }

                // In the dev we use on-demand-entries.
                // So, it makes no sense to use commonChunks based on the minChunks count.
                // Instead, we move all the code in node_modules into each of the pages.
                if (dev) {
                  return false;
                }

                // If there are one or two pages, only move modules to common if they are
                // used in all of the pages. Otherwise, move modules used in at-least
                // 1/2 of the total pages into commons.
                if (totalPages <= 2) {
                  return count >= totalPages;
                }
                return count >= totalPages * 0.5;
              }
            }),
            // This chunk splits out react and react-dom in production to make sure it does not go through uglify. This saved multiple seconds on production builds.
            // See https://twitter.com/dan_abramov/status/944040306420408325
            new _webpack2.default.optimize.CommonsChunkPlugin({
              name: 'react',
              filename: 'react.js',
              minChunks: function minChunks(module, count) {
                if (dev) {
                  return false;
                }

                if (module.resource && module.resource.includes(_path.sep + 'react-dom' + _path.sep) && count >= 0) {
                  return true;
                }

                if (module.resource && module.resource.includes(_path.sep + 'react' + _path.sep) && count >= 0) {
                  return true;
                }

                return false;
              }
            }),
            // This chunk contains all the webpack related code. So, all the changes
            // related to that happens to this chunk.
            // It won't touch commons.js and that gives us much better re-build perf.
            new _webpack2.default.optimize.CommonsChunkPlugin({
              name: 'manifest',
              filename: 'manifest.js'
            }),

            // This adds Next.js route definitions to page bundles
            new _pagesPlugin2.default(),
            // Implements support for dynamic imports
            new _dynamicChunksPlugin2.default()];


            if (dev) {
              plugins.push(new _webpack2.default.HotModuleReplacementPlugin(), new _webpack2.default.NoEmitOnErrorsPlugin(), new _unlinkFilePlugin2.default());
              if (!quiet) {
                plugins.push(new _friendlyErrorsWebpackPlugin2.default());
              }
            } else {
              plugins.push(new _webpack2.default.IgnorePlugin(/react-hot-loader/));
              plugins.push(
              // Minifies javascript bundles
              new _uglifyjsWebpackPlugin2.default({
                exclude: /react\.js/,
                parallel: true,
                sourceMap: false,
                uglifyOptions: {
                  compress: {
                    comparisons: false
                  }
                }
              }));
              plugins.push(
              // Combines manifest.js commons.js and main.js into app.js in production
              new _combineAssetsPlugin2.default({
                input: ['manifest.js', 'react.js', 'commons.js', 'main.js'],
                output: 'app.js'
              }));
              // Implements scope hoisting which speeds up browser execution of javascript
              plugins.push(new _webpack2.default.optimize.ModuleConcatenationPlugin());
            }

            nodePathList = (process.env.NODE_PATH || '').split(process.platform === 'win32' ? ';' : ':').filter(function (p) {
              return !!p;
            });
            mainBabelOptions = {
              cacheDirectory: true,
              presets: []
            };
            externalBabelConfig = (0, _findConfig2.default)(dir);

            if (externalBabelConfig) {
              console.log('> Using external babel configuration');
              console.log('> Location: "' + externalBabelConfig.loc + '"');
              // It's possible to turn off babelrc support via babelrc itself.
              // In that case, we should add our default preset.
              // That's why we need to do this.
              options = externalBabelConfig.options;

              mainBabelOptions.babelrc = options.babelrc !== false;
            } else {
              mainBabelOptions.babelrc = false;
            }

            // Add our default preset if the no "babelrc" found.
            if (!mainBabelOptions.babelrc) {
              mainBabelOptions.presets.push(require.resolve('./babel/preset'));
            }

            devLoaders = dev ? [{
              test: /\.(js|jsx)(\?[^?]*)?$/,
              loader: 'hot-self-accept-loader',
              include: [(0, _path.join)(dir, 'pages'), nextPagesDir]
            }, {
              test: /\.(js|jsx)(\?[^?]*)?$/,
              loader: 'react-hot-loader/webpack',
              exclude: /node_modules/
            }] : [];
            loaders = [{
              test: /\.json$/,
              loader: 'json-loader'
            }, {
              test: /\.(js|jsx|json)(\?[^?]*)?$/,
              loader: 'emit-file-loader',
              include: [dir, nextPagesDir],
              exclude: function exclude(str) {
                return (/node_modules/.test(str) && str.indexOf(nextPagesDir) !== 0
                );
              },

              options: {
                name: 'dist/[path][name].[ext]',
                // We need to strip off .jsx on the server. Otherwise require without .jsx doesn't work.
                interpolateName: function interpolateName(name) {
                  return name.replace('.jsx', '.js');
                },
                validateFileName: function validateFileName(file) {
                  var cases = [{ from: '.js', to: '.jsx' }, { from: '.jsx', to: '.js' }];

                  var _iteratorNormalCompletion3 = true;
                  var _didIteratorError3 = false;
                  var _iteratorError3 = undefined;

                  try {
                    for (var _iterator3 = (0, _getIterator3.default)(cases), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                      var item = _step3.value;
                      var from = item.from,
                          to = item.to;

                      if (file.slice(-from.length) !== from) {
                        continue;
                      }

                      var filePath = file.slice(0, -from.length) + to;

                      if ((0, _fs.existsSync)(filePath)) {
                        throw new Error('Both ' + from + ' and ' + to + ' file found. Please make sure you only have one of both.');
                      }
                    }
                  } catch (err) {
                    _didIteratorError3 = true;
                    _iteratorError3 = err;
                  } finally {
                    try {
                      if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                      }
                    } finally {
                      if (_didIteratorError3) {
                        throw _iteratorError3;
                      }
                    }
                  }
                },

                // By default, our babel config does not transpile ES2015 module syntax because
                // webpack knows how to handle them. (That's how it can do tree-shaking)
                // But Node.js doesn't know how to handle them. So, we have to transpile them here.
                transform: function transform(_ref6) {
                  var content = _ref6.content,
                      sourceMap = _ref6.sourceMap,
                      interpolatedName = _ref6.interpolatedName;

                  // Only handle .js files
                  if (!/\.(js|jsx)$/.test(interpolatedName)) {
                    return { content: content, sourceMap: sourceMap };
                  }

                  var transpiled = babelCore.transform(content, {
                    babelrc: false,
                    sourceMaps: dev ? 'both' : false,
                    // Here we need to resolve all modules to the absolute paths.
                    // Earlier we did it with the babel-preset.
                    // But since we don't transpile ES2015 in the preset this is not resolving.
                    // That's why we need to do it here.
                    // See more: https://github.com/zeit/next.js/issues/951
                    plugins: [require.resolve((0, _path.join)(__dirname, './babel/plugins/remove-dotjsx-from-import.js')), [require.resolve('babel-plugin-transform-es2015-modules-commonjs')], [require.resolve('babel-plugin-module-resolver'), {
                      alias: {
                        'babel-runtime': relativeResolve('babel-runtime/package'),
                        'next/link': relativeResolve('../../lib/link'),
                        'next/prefetch': relativeResolve('../../lib/prefetch'),
                        'next/css': relativeResolve('../../lib/css'),
                        'next/dynamic': relativeResolve('../../lib/dynamic'),
                        'next/head': relativeResolve('../../lib/head'),
                        'next/document': relativeResolve('../../server/document'),
                        'next/router': relativeResolve('../../lib/router'),
                        'next/error': relativeResolve('../../lib/error'),
                        'styled-jsx/style': relativeResolve('styled-jsx/style')
                      }
                    }]],
                    inputSourceMap: sourceMap
                  });

                  // Strip ?entry to map back to filesystem and work with iTerm, etc.
                  var map = transpiled.map;

                  var output = transpiled.code;

                  if (map) {
                    var nodeMap = (0, _assign2.default)({}, map);
                    nodeMap.sources = nodeMap.sources.map(function (source) {
                      return source.replace(/\?entry/, '');
                    });
                    delete nodeMap.sourcesContent;

                    // Output explicit inline source map that source-map-support can pickup via requireHook mode.
                    // Since these are not formal chunks, the devtool infrastructure in webpack does not output
                    // a source map for these files.
                    var sourceMapUrl = new Buffer((0, _stringify2.default)(nodeMap), 'utf-8').toString('base64');
                    output = output + '\n//# sourceMappingURL=data:application/json;charset=utf-8;base64,' + sourceMapUrl;
                  }

                  return {
                    content: output,
                    sourceMap: transpiled.map
                  };
                }
              }
            }, {
              loader: 'babel-loader',
              include: nextPagesDir,
              exclude: function exclude(str) {
                return (/node_modules/.test(str) && str.indexOf(nextPagesDir) !== 0
                );
              },

              options: {
                babelrc: false,
                cacheDirectory: true,
                presets: [require.resolve('./babel/preset')]
              }
            }, {
              test: /\.(js|jsx)(\?[^?]*)?$/,
              loader: 'babel-loader',
              include: [dir],
              exclude: function exclude(str) {
                return (/node_modules/.test(str)
                );
              },

              options: mainBabelOptions
            }];
            webpackConfig = {
              context: dir,
              entry: entry,
              output: {
                path: buildDir ? (0, _path.join)(buildDir, '.next') : (0, _path.join)(dir, config.distDir),
                filename: '[name]',
                libraryTarget: 'commonjs2',
                publicPath: '/_next/webpack/',
                strictModuleExceptionHandling: true,
                devtoolModuleFilenameTemplate: function devtoolModuleFilenameTemplate(_ref7) {
                  var resourcePath = _ref7.resourcePath;

                  var hash = (0, _crypto.createHash)('sha1');
                  hash.update(Date.now() + '');
                  var id = hash.digest('hex').slice(0, 7);

                  // append hash id for cache busting
                  return 'webpack:///' + resourcePath + '?' + id;
                },

                // This saves chunks with the name given via require.ensure()
                chunkFilename: '[name]-[chunkhash].js'
              },
              resolve: {
                alias: {
                  // This bypasses React's check for production mode. Since we know it is in production this way.
                  // This allows us to exclude React from being uglified. Saving multiple seconds per build.
                  'react-dom': dev ? 'react-dom/cjs/react-dom.development.js' : 'react-dom/cjs/react-dom.production.min.js'
                },
                extensions: ['.js', '.jsx', '.json'],
                modules: [nextNodeModulesDir, 'node_modules'].concat((0, _toConsumableArray3.default)(nodePathList))
              },
              resolveLoader: {
                modules: [nextNodeModulesDir, 'node_modules', (0, _path.join)(__dirname, 'loaders')].concat((0, _toConsumableArray3.default)(nodePathList))
              },
              plugins: plugins,
              module: {
                rules: [].concat(devLoaders, loaders)
              },
              devtool: dev ? 'cheap-module-inline-source-map' : false,
              performance: { hints: false }
            };

            if (!config.webpack) {
              _context3.next = 21;
              break;
            }

            console.log('> Using "webpack" config function defined in ' + config.configOrigin + '.');
            _context3.next = 20;
            return config.webpack(webpackConfig, { buildId: buildId, dev: dev });

          case 20:
            webpackConfig = _context3.sent;

          case 21:
            return _context3.abrupt('return', (0, _webpack2.default)(webpackConfig));

          case 22:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  function createCompiler(_x3) {
    return _ref3.apply(this, arguments);
  }

  return createCompiler;
}();